import * as z from 'zod';
import { Prisma } from '../../../generated/prisma';
import Decimal from 'decimal.js';
import { IntFilterObjectSchema as IntFilterObjectSchema } from './IntFilter.schema';
import { DecimalFilterObjectSchema as DecimalFilterObjectSchema } from './DecimalFilter.schema';
import { StringNullableFilterObjectSchema as StringNullableFilterObjectSchema } from './StringNullableFilter.schema';
import { DateTimeFilterObjectSchema as DateTimeFilterObjectSchema } from './DateTimeFilter.schema'

import { DecimalJSLikeSchema, isValidDecimalInput } from '../../helpers/decimal-helpers';
const commissionbatchscalarwhereinputSchema = z.object({
  AND: z.union([z.lazy(() => CommissionBatchScalarWhereInputObjectSchema), z.lazy(() => CommissionBatchScalarWhereInputObjectSchema).array()]).optional(),
  OR: z.lazy(() => CommissionBatchScalarWhereInputObjectSchema).array().optional(),
  NOT: z.union([z.lazy(() => CommissionBatchScalarWhereInputObjectSchema), z.lazy(() => CommissionBatchScalarWhereInputObjectSchema).array()]).optional(),
  id: z.union([z.lazy(() => IntFilterObjectSchema), z.number().int()]).optional(),
  npiProviderId: z.union([z.lazy(() => IntFilterObjectSchema), z.number().int()]).optional(),
  totalCollection: z.union([z.lazy(() => DecimalFilterObjectSchema), z.union([
  z.number(),
  z.string(),
  z.instanceof(Decimal),
  z.instanceof(Prisma.Decimal),
  DecimalJSLikeSchema,
]).refine((v) => isValidDecimalInput(v), {
  message: "Field 'totalCollection' must be a Decimal",
})]).optional(),
  commissionAmount: z.union([z.lazy(() => DecimalFilterObjectSchema), z.union([
  z.number(),
  z.string(),
  z.instanceof(Decimal),
  z.instanceof(Prisma.Decimal),
  DecimalJSLikeSchema,
]).refine((v) => isValidDecimalInput(v), {
  message: "Field 'commissionAmount' must be a Decimal",
})]).optional(),
  notes: z.union([z.lazy(() => StringNullableFilterObjectSchema), z.string()]).optional().nullable(),
  createdAt: z.union([z.lazy(() => DateTimeFilterObjectSchema), z.coerce.date()]).optional()
}).strict();
export const CommissionBatchScalarWhereInputObjectSchema: z.ZodType<Prisma.CommissionBatchScalarWhereInput> = commissionbatchscalarwhereinputSchema as unknown as z.ZodType<Prisma.CommissionBatchScalarWhereInput>;
export const CommissionBatchScalarWhereInputObjectZodSchema = commissionbatchscalarwhereinputSchema;
